#
# osc-oracle-ocfs2.spec
#

#
#  Copyright (C) 2008, 2010 Oracle.  All rights reserved.
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public
#  License as published by the Free Software Foundation, version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public
#  License along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 021110-1307, USA
#

#
# Oracle Storage Connect plugin .spec file
#

#
# These defines need to be set to reflect the specific plugin
#
%define     vendor_name     oracle
%define     plugin_module   ocfs2

Vendor:     Oracle America
Summary:    Oracle Storage Connect ocfs2 Plugin
URL:        http://oss.oracle.com/projects/ocfs2

License:    GPLv2
BuildArch:  noarch

###########################################################################
#                                                                         #
# If the plug-in requires Java uncomment the following line and make sure #
# the correct version is referenced                                       #
#                                                                         #
###########################################################################
#Requires:   jdk >= 1.6.0_20-fcs


###########################################################################
#                                                                         #
# The following defines are generic and should not need to be changed     #
#                                                                         #
###########################################################################

%define     dist            .el6
%define     build_dir       %{_builddir}/%{name}-%{version}
%define     plugin_dir      /opt/storage-connect/plugins
%define     vendor_dir      %{plugin_dir}/%{vendor_name}
%define     install_dir     %{vendor_dir}/%{plugin_module}
%define     sharedoc_dir    /usr/share/doc/%{name}
%define     ocfs2_files     __init__.py OCFS2.py
%define     ocfs2_src_dir   OCFS2

Name:       osc-%{vendor_name}-%{plugin_module}
Version:    0.1.0
Release: 42%{dist}
Group:      Oracle/StorageConnect
Source0:    %{name}-%{version}.tar.bz2
Patch1: dummy.patch
Patch2: patch1228.patch_23144
Patch3: update-to-1.2.1.patch
Patch4: ssinfo-remove-nones.patch
Patch5: patch1468.patch
Patch6: patch1621.patch_32510
Patch7: fixed-required_api_ver.patch
Patch8: patch9438.patch
Patch9: moved-__plugin_release__.patch
Patch10: fs_record-state.patch
Patch11: changed-dev-scanning-to-use-iplugin-paths.patch
Patch12: remove-training-wheels.patch
Patch13: fixed-missing-param.patch
Patch14: check-path-exist-before-list.patch
Patch15: patch611.patch
Patch16: set-cluster-required.patch
Patch17: patch3637.patch
Patch18: patch8647.patch_17573
Patch19: patch8839.patch_17852
Patch20: strip_path.patch
Patch21: file_size.patch
Patch22: listFileSystems_no_exceptions.patch
Patch23: free_sz_not_supported.patch
Patch24: local_ocfs2_fs_creation_better_mkfs_params.patch
Patch25: fix-umask.patch
Patch26: patch7717.patch
Patch27: lower_case_uuid.patch
Patch28: patch2003.patch
Patch29: free_sz_support.patch
Patch30: hack_for_ocfs2_local_mkfs_determined_by_server.patch
Patch31: rev279.patch
Patch32: add_free_size.patch
Patch33: breakup_blkid.patch
Patch34: chk_partitions.patch
Patch35: rev337.patch
Patch36: change-storage-discover-command-dir.patch
Patch37: Jblock64.patch
Patch38: rev424.patch
Patch39: clustertracking.patch
Patch40: more_clustername.patch
# End Oracle Patches

BuildRoot:  %{_tmppath}/%{name}-%{version}
Requires:   osc-plugin-manager >= 1.0.9
Requires:   ocfs2-tools >= 1.6.0

%description
Oracle Storage Connect plugin for the ocfs2 filesystem.

%prep
%setup -q
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch27 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p0
%patch31 -p0
%patch32 -p0
%patch33 -p0
%patch34 -p0
%patch35 -p0
%patch36 -p0
%patch37 -p0
%patch38 -p0
%patch39 -p0
%patch40 -p0

%build

%install
rm -fr %{buildroot}
install -d -m0755 %{buildroot}/%{install_dir}
install -d -m0755 %{buildroot}/%{sharedoc_dir}
mv %{build_dir}/%{ocfs2_src_dir}/COPYING %{buildroot}/%{sharedoc_dir}/.
rm -fr %{build_dir}/%{sharedoc_dir}
plugin_release=%{release}
plugin_release=${plugin_release/%{dist}/}
for ocfs2_file in %{ocfs2_files}
do
  sed -i "s/\(__plugin_release__.*=.*\)\"-0-\"/\1\"${plugin_release}\"/" \
          %{build_dir}/%{ocfs2_src_dir}/${ocfs2_file}
  mv %{build_dir}/%{ocfs2_src_dir}/${ocfs2_file} %{buildroot}/%{install_dir}/.
done

%clean
rm -fr %{buildroot}

%files
%defattr(0555, root, root, 0755)
%attr(0555, root, root) %{install_dir}/*
%doc %{sharedoc_dir}/*

%%preun
if [ $1 -eq 0 ]
then
    OSC_BIN=/opt/storage-connect/bin
    if [ -x "$OSC_BIN/announce_erase" ]
    then
        $OSC_BIN/announce_erase "%{name}" \
                                "%{version}-%{release}" \
                                "%{install_dir}" \
                                "%{vendor_name}" \
                                "%{plugin_module}"
    fi
    if [ -f %{vendor_dir}/__init__.py ]
    then
        python %{vendor_dir}/__init__.py %{vendor_dir} >/dev/null 2>&1
        if [ "$?" -eq 0 ]
        then
            rm -f %{vendor_dir}/__init__.py
            rm -f %{vendor_dir}/__init__.pyc
            rm -f %{vendor_dir}/__init__.pyo
        fi
    fi
fi
exit 0

%postun
if [ $1 -ge 1 ]
then
    OSC_BIN=/opt/storage-connect/bin
    if [ -x "$OSC_BIN/announce_upgrade" ]
    then
        $OSC_BIN/announce_upgrade "%{name}" \
                                  "%{version}-%{release}" \
                                  "%{install_dir}" \
                                  "%{vendor_name}" \
                                  "%{plugin_module}"
     fi
elif [ $1 -eq 0 ]
then
    rmdir --ignore-fail-on-non-empty %{install_dir} 2>/dev/null
    rmdir --ignore-fail-on-non-empty %{vendor_dir} 2>/dev/null
fi
exit 0

%post
OSC_BIN=/opt/storage-connect/bin
if [ -x "$OSC_BIN/announce_install" ]
then
    $OSC_BIN/announce_install "%{name}" \
                              "%{version}-%{release}" \
                              "%{install_dir}" \
                              "%{vendor_name}" \
                              "%{plugin_module}"
fi
if [ ! -f %{vendor_dir}/__init__.py ]
then
    cat >%{vendor_dir}/__init__.py <<__EOF__
#!/usr/bin/env python
"""
@copyright: Copyright (C) 2008, 2010 Oracle.  All rights reserved.

@license:   This program is free software; you can redistribute it and/or
            modify it under the terms of the GNU General Public
            License as published by the Free Software Foundation, version 2.

            This program is distributed in the hope that it will be useful,
            but WITHOUT ANY WARRANTY; without even the implied warranty of
            MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
            General Public License for more details.

            You should have received a copy of the GNU General Public
            License along with this program; if not, write to the Free Software
            Foundation, Inc., 59 Temple Place - Suite 330, Boston,
            MA 021110-1307, USA

@summary:   This is just to enable the import of the plugins.
"""

#
# This is a major hack to get around RPM's limitation of not being able
# to specify the same file for multiple RPM installs
#
# Exit codes:
#   0 : No more dependencies
#   1 : ERROR condition
#   2 : Still have dependencies
#
if __name__ == '__main__':
    import sys
    import os
    if len(sys.argv) <= 1:
        print "ERROR: No vendor dir given!"
        sys.exit(1)

    try:
       vendor_dirs = os.listdir(sys.argv[1])
       ref_count = 0
       for vendor_dir in vendor_dirs:
           vendor_path = os.path.join(sys.argv[1], vendor_dir)
           if os.path.isdir(vendor_path):
               ref_count += 1

    except Exception, e:
        print "ERROR:", e
        sys.exit(1)

    if ref_count > 1:
        sys.exit(2)

    sys.exit(0)

__EOF__
fi
exit 0

%changelog
* Wed Feb 12 2014 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-42 
- Fixed clustername not returned in start and stopPresent 

* Mon Feb 03 2014 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-41 
- Added cluster_name to the fsrecord.
  Oracle_Bug: 18093901 

* Fri Aug 23 2013 Carson Hovey <carson.hovey@oracle.com> - 0.1.0-40
- Bug 17258567 - Change directory protection from 0555 to 0755 
  Signed-off-by: Cathy.Avery <cathy.avery@oracle.com>

* Thu May 23 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 0.1.0-39 
- when the backing device is a linear device mapper, create local filesystem instead of clustered.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> 

* Thu Nov 29 2012 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-38 
- Added -J block64 in mkfs.ocfs to allow for 16T and greater repos. [bug 15917811]  

* Wed Jul 25 2012 Jingjie Jiang <jingjie.jiang@oracle.com> - 0.1.0-37 
- hange the /usr/bin/storage_discover to /usr/sbin/storage_discover since the ovs-storage-utils merged into ovs-agant and use the same directory for the commands as ovs-agent.
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Jingjie Jiang <jingjie.jiang@oracle.com> 

* Fri Mar 23 2012 Junjie Wei <junjie.wei@oracle.com> - 0.1.0-36 
- Set the default node slots to 32.
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Xiaodong Yang <xiao.dong.yang@oracle.com> [bug 13847335] 

* Thu Feb 23 2012 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-35 
- Check for partitions throw exception and log error message during createFileSystem [bug 13596838] 

* Mon Feb 20 2012 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-34 
- Break blkid call so it is not overloaded on the command line [bug 13604776] 

* Thu Feb 02 2012 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-33 
- Added fs_record['free_sz'] to getFileSystemInfo 

* Fri Jan 20 2012 Junjie Wei <junjie.wei@oracle.com> - 0.1.0-32 
- Add support of ocfs2 device on-disk cluster stack update.
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Sunil Mushran <sunil.mushran@oracle.com> 

* Fri Jul 22 2011 Kurt Hackel <kurt.hackel@oracle.com> - 0.1.0-31 
- Adds a hack to the ocfs2 plugin so that the server determines independently whether to mkfs with "local" or clustered options.  It will check storage utils (same thing used by discovery so should match the Manager) to see if the LUN is "local".
  We should change this when possible by splitting the ocfs2 plugin into local and cluster personalities and putting all the rules in core to understand when each can be used. 

* Thu Jul 14 2011 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-30 
- Added fs free size. [bug 12751736] 

* Thu Jul 14 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 0.1.0-29 
-  

* Mon Jul 11 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-28 
- Lower case the UUID coming from debugfs.ocfs2 as all other UUIDs are lower
  case
  bug: 12738835 

* Fri Jul 08 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-27 
- Changed to create the file system with the 'name' as the UUID... 

* Thu Jul 07 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 0.1.0-26 
- fix umask
  We don't need to calculate the mode or chmod.
  For os.mknod: default mode is 0600, default node type is stat.S_IFREG, umask is 077, the actual mode (mode & ~umask) will be 0600.
  For os.mkdir: default mode is 0777, umask is 077, the actual mode (mode & ~umask) will be 0700.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 12719289] 

* Tue Jul 05 2011 Kurt Hackel <kurt.hackel@oracle.com> - 0.1.0-25 
- Allow ocfs2 plugin to create local-only filesystems as well as clustered.
  Use more sensible mkfs params for vm storage. 

* Thu Jun 09 2011 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-24 
- fs_record['free_sz'] is now set to -1 which means not supported 

* Thu Jun 09 2011 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-23 
- listFileSystems no longer throws exception when encountering fs error but logs error.
  Oracle_Bug: 12543055 

* Mon Apr 25 2011 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-22 
- Added code to get file size. [bug 12387768] 

* Thu Apr 07 2011 Cathy Avery <cathy.avery@oracle.com> - 0.1.0-21 
- strip path away for device compare in destroyFileSystem [bug 11871942] 

* Tue Feb 15 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-20 
- Added import fnmatch 

* Thu Feb 10 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-19 
- Fixed file filtering in list command 

* Mon Jan 31 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-18 
- Fixed create() command args... 

* Thu Jan 27 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-17 
- Set the cluster required capability 

* Wed Jan 26 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-16 
- UUIDs to be returned as strings and not objects 

* Wed Jan 26 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-15 
- Should not throw an exception if there are no devices on the system, rather just return no file systems..
  bug:11679187 

* Fri Jan 14 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-14 
- Fixed missing param with _validateFSRecord in destroyFileSystem 

* Thu Jan 13 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-13 
- Removed the default raise in the destroyFileSystem() method 

* Wed Jan 12 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-12 
- Changed the device scanning to obey the IPlugin device path and regex 

* Thu Jan 06 2011 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-11 
- Added state to the fs_record
  bug:10640078 

* Thu Dec 23 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-10 
- Moved __plugin_release__ from __init__.py to OCFS2.py 

* Wed Dec 22 2010 Joel Becker <joel.becker@oracle.com> - 0.1.0-9 
- OCFS2.py: More updates for spec 1.27 (1.2.7?)
  - Make mount()/unmount()'s keyword arguments match OSCPlugin.py
  - Test the new mount arguments
  - Make the filesys_path -> backing_device changes to testocfs2.py
  - Add isSplittable()
  - Test isSplittable()
  Signed-off-by: Joel Becker <joel.becker@oracle.com> 

* Wed Dec 22 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-8 
- Fixed typo in required_api_ver 

* Wed Dec 22 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-7 
- Updated to spec version 1.27;
  replaced filesys_path with backing_device;
  removed list_can_filter and thin_clone from plugin_ability, and added the backing_device_type (set to single device);
  added create/destroy mount point flags to mount/unmount respectively;
  added kludge to keep the plugin -release in sync with the .spec file (auto patch rev the -release on every patch)
  patch-name:update-to-1.27-spec.patch 

* Wed Dec 22 2010 Joel Becker <joel.becker@oracle.com> - 0.1.0-6 
- testocfs2: Fix a few test errors that cause problems on 1.24
  Signed-off-by: Joel Becker <joel.becker@oracle.com> 

* Thu Aug 19 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-5 
- Changed fillSSInfo to not set fields to None, Changed the AccessGroup return a valid dict (for now) This call should never be called since the flag is set to indicate that Access control is not supported 

* Wed Aug 18 2010 Wiekus Beukes <wiekus.beukes@oracle.com> - 0.1.0-4 
- Remove filesys_type from fs_record, update QoS dict, changed BlockBased to LocalFileSystem 

* Tue Aug 17 2010 Joel Becker <joel.becker@oracle.com> - 0.1.0-3 
- OCFS2/testocfs2: Update to the new filesys_type=Block changes.
  Keep up with OSCPlugin's change of filesys_type to a generic Block type.
  Signed-off-by: Joel Becker <joel.becker@oracle.com> 

* Tue Jun 10 2010 Wiekus Beukes <wiekus.beukes@oracle.com> 0.1.0-2
- Fixing many bugs as uncovered by the cert testing
- Fixed issues with RPM and generated __init__.py file

* Fri May 28 2010 Joel Becker <joel.becker@oracle.com> 0.1.0-1
- Initial ocfs2 version of this specfile

